﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
//using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using System.Collections;

namespace WindowsFormsApplication21
{

    public partial class Form1 : Form
    {
        private DataTable table;
        public Form1()
        {

            InitializeComponent();
          
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.DataSource = ReturnATable();
            //set cellvaluetype
            this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyCell.CellValueType = typeof(DateTime);
            //set datatime format
            this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyCell.Format = "MMM-yyyy";
            //event
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

        }
        #region event
        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell && e.TableCellIdentity.GroupedColumn != null)
            {
                GridCaptionRow captionRow = e.TableCellIdentity.DisplayElement as GridCaptionRow;
                string date = "";
                DateTime dt;
                if (e.Style.Text != null && DateTime.TryParse(e.Style.Text.Substring(e.Style.Text.IndexOf(":") + 1, 8), out dt))
                {
                    date = dt.ToString("MMM-yyyy");

                }
                e.Style.CellValue = String.Format("{0}: {1} Items.", date, e.TableCellIdentity.DisplayElement.ParentGroup.GetChildCount());
            }
        }
        #endregion

        #region Datatable
        private DataTable ReturnATable()
        {
            table = new DataTable("People");

            //Adds two columns.
            table.Columns.Add(new DataColumn("FirstName"));
            table.Columns.Add(new DataColumn("LastName"));
            table.Columns.Add(new DataColumn("Date"));
            table.Columns.Add(new DataColumn("Age"));

            //Adds some rows.
            DataRow dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Smith";
            dr["Date"] = "2/5/15";
            dr["Age"] = 29;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "2/2/12";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "2/5/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "4/4/10";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "8/1/15";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "4/4/10";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "3/4/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "7/8/12";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "3/4/15";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "6/9/13";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "3/4/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "5/12/14";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "2/2/10";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Mary";
            dr["LastName"] = "Tucker";
            dr["Date"] = "1/2/13";
            dr["Age"] = 42;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Becky";
            dr["LastName"] = "Dunsford";
            dr["Date"] = "6/2/10";
            dr["Age"] = 33;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "9/2/10";
            dr["Age"] = 38;
            table.Rows.Add(dr);

            return table;
        }
        #endregion

    }
       
}
